package com.company.demo.component;

import com.vaadin.flow.component.Component;
import com.vaadin.flow.component.HasValue;
import io.jmix.flowui.component.delegate.AbstractValueComponentDelegate;
import io.jmix.flowui.data.ValueSource;
import io.jmix.flowui.data.binding.impl.AbstractValueBinding;
import org.springframework.beans.BeansException;
import org.springframework.beans.factory.config.BeanDefinition;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.context.annotation.Scope;

@org.springframework.stereotype.Component("demo_MasterDataFieldDelegate")
@Scope(BeanDefinition.SCOPE_PROTOTYPE)
public class MasterDataFieldDelegate<C extends Component & HasValue<?, V>, T, V>
        extends AbstractValueComponentDelegate<C, T, V>
        implements ApplicationContextAware {

    protected ApplicationContext applicationContext;

    public MasterDataFieldDelegate(C component) {
        super(component);
    }

    @Override
    public void setApplicationContext(ApplicationContext applicationContext) throws BeansException {
        this.applicationContext = applicationContext;
    }

    @Override
    protected AbstractValueBinding<T> createValueBinding(ValueSource<T> valueSource) {
        return applicationContext.getBean(MasterDataFieldBinding.class, valueSource, component);
    }
}
