package com.company.demo.view.project;

import com.company.demo.component.MasterDataField;
import com.company.demo.entity.Project;
import com.company.demo.view.main.MainView;
import com.vaadin.flow.component.notification.Notification;
import com.vaadin.flow.router.Route;
import io.jmix.flowui.Notifications;
import io.jmix.flowui.UiComponents;
import io.jmix.flowui.component.formlayout.JmixFormLayout;
import io.jmix.flowui.data.value.ContainerValueSource;
import io.jmix.flowui.model.InstanceContainer;
import io.jmix.flowui.view.*;
import org.springframework.beans.factory.annotation.Autowired;

@Route(value = "projects/:id", layout = MainView.class)
@ViewController(id = "Project.detail")
@ViewDescriptor(path = "project-detail-view.xml")
@EditedEntityContainer("projectDc")
public class ProjectDetailView extends StandardDetailView<Project> {

    @Autowired
    private UiComponents uiComponents;
    @ViewComponent
    private JmixFormLayout form;
    @ViewComponent
    private InstanceContainer<Project> projectDc;
    @Autowired
    private Notifications notifications;

    @Subscribe
    public void onInit(final InitEvent event) {
        MasterDataField<String> masterDataField = uiComponents.create(MasterDataField.class);
        masterDataField.setWidthFull();
        masterDataField.setValueSource(new ContainerValueSource<>(projectDc, "expandTeam"));

        masterDataField.addValueChangeListener(event1 -> {
            notifications.create("VCE")
                    .withPosition(Notification.Position.BOTTOM_END)
                    .show();
        });

        form.add(masterDataField);
    }
}